unit Speler_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DateUtils;

type
  TSpeler = class(TObject)

  private
      fEpos: String;
      fNaam: String;
      fGebDatum: String;
      fGoedgekeur: Boolean;
      function toetsEpos(sEpos: String): Boolean;

  public
    constructor create(sNaam, sEpos, sGebDatum: String);
    function toString: String;
    function toetsOuderdom(iMinOuderdom : integer): String;
    procedure setGoedgekeur(bGoedkeur : boolean);
    function getEpos: String;
   end;

implementation

{ TSpeler }

// 3.1.1
function TSpeler.getEpos: String;
begin
   result := fEpos;
end;

// 3.1.2
procedure TSpeler.setGoedgekeur(bGoedkeur: boolean);
begin
   fGoedgekeur := bGoedkeur;
end;

// 3.1.3
function TSpeler.toetsEpos(sEpos: String): Boolean;
var
   bSlaag: boolean;
begin
   bSlaag := true;
   if NOT (Uppercase(sEpos)[1] IN ['A'..'Z']) then
      bSlaag := False
   else
      bSlaag := False;
   result := bSlaag;
end;
// 3.1.4

constructor TSpeler.create(sNaam, sEpos, sGebDatum: String);
begin
   fNaam := sNaam;
   if toetsEpos(sEpos) then
     fEpos := sEpos
    else
     fEpos := 'FOUT';
   fGebDatum := sGebDatum;
   fGoedgekeur := false;
end;

// 3.1.5
function TSpeler.toetsOuderdom(iMinOuderdom: integer): String;
var
   iOuderdom : Integer;
begin
    iOuderdom  := YearsBetween(date,StrToDate(fGebDatum));

    if iOuderdom  >= iMinOuderdom then
      result := 'GOEDGEKEUR'
     else
      result := 'AFGEKEUR';
end;


// Kode wat voorsien is - moenie verander nie

function TSpeler.toString: String;
var
 sAfvoer, sGoedgekeur: String;
begin
  sAfvoer := 'Naam: ' + fNaam + #13;
  sAfvoer := sAfvoer + 'E-posadres: ' + fEpos + #13;
  sAfvoer := sAfvoer + 'Geboortedatum: ' + fGebDatum + #13;
  if fGoedgekeur then
     sGoedgekeur := 'JA'
    else
     sGoedgekeur := 'NEE';
  sAfvoer := sAfvoer + 'Goedgekeur: ' + sGoedgekeur + #13;
  result := sAfvoer;
end;


end.
