unit question4_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TfrmQuestion4 = class(TForm)
    Label1: TLabel;
    redDisplay: TRichEdit;
    Label2: TLabel;
    btnload: TButton;
    btnRemoveDuplicates: TButton;
    btnMasterPlayers: TButton;
    procedure btnloadClick(Sender: TObject);
    procedure display;
    procedure btnRemoveDuplicatesClick(Sender: TObject);
    procedure btnMasterPlayersClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQuestion4: TfrmQuestion4;
  arrNames: array [1..50] of String;
  arrScores: array [1..50] of Integer;
  iCount: integer = 0;

  arrMasters: array[1..30] of String;
  iMastCount: Integer;

implementation

{$R *.dfm}


procedure TfrmQuestion4.btnRemoveDuplicatesClick(Sender: TObject);
var
  arrTempNames: array [1..50] of String;
  arrTempScores: array [1..50] of Integer;
  i, j, newCount : Integer;
  found : boolean;
begin
   // Question 4.1 Remove lower duplicates
     newCount := 0;
     for i := 1 to iCount do
      begin
        found := false;
        for j := 1 to  newCount do
           begin
             if arrNames[i] = arrTempNames[j] then
              begin
                found := true;
                if arrScores[i] > arrTempScores[j] then
                 arrTempScores[j] := arrScores[i];
              end;
           end;
           if NOT found then
             begin
               Inc(newCount);
               arrTempNames[newCount] := arrNames[i];
               arrTempScores[newCount] := arrScores[i];
             end;
      end;
      iCount := newCount;
      for i := 1 to iCount do
        begin
          arrNames[i] := arrTempNames[i];
          arrScores[i] := arrTempScores[i];
        end;
     display;
end;


procedure TfrmQuestion4.btnMasterPlayersClick(Sender: TObject);
var
  i, j, iTot, iAvg : integer;
  sTemp : String;
begin
  // Question 4.2 Get Masters and display sorted list
  iTot := 0;
  for i := 1 to iCount do
    iTot := iTot + arrScores[i];
  iAvg := Round(iTot / iCount);

  iMastCount := 0;
  for i := 1 to iCount do
   if arrScores[i] > iAvg then
     begin
        Inc(iMastCount);
        arrMasters[iMastCount] := arrNames[i] + '#' + IntToStr(arrScores[i]);
     end;

   for i := 1 to iMastCount - 1 do
    for j := i + 1 to iMastCount do
      if arrMasters[i] > arrMasters[j]  then
        begin
          sTemp := arrMasters[i];
          arrMasters[i] := arrMasters[j];
          arrMasters[j] := sTemp;
        end;

   redDisplay.Clear;
   redDisplay.Lines.Add('MASTER PLAYERS');
   redDisplay.Lines.Add('Scores above an average of ' + IntToStr(iAvg));
   for i := 1 to iMastCount do
     redDisplay.Lines.Add(arrMasters[i]);
end;



// Supplied Code

procedure TfrmQuestion4.btnloadClick(Sender: TObject);
var
  tScoresFile: TextFile;
  sLine : String;
  p: Integer;
begin
   iCount :=0;
   AssignFile(tScoresFile, 'Scores.txt');
   Reset(tScoresFile);
   while NOT EOF(tScoresFile) do
    begin
      Inc(iCount);
      Readln(tScoresFile, sLine);
      p := Pos(',',sLine);
      arrNames[iCount] := Copy(sLine,1,p-1);
      arrScores[iCount] := StrToInt(Copy(sLine,p+1));
    end;
    CloseFile(tScoresFile);
    display;
end;


procedure TfrmQuestion4.display;
var
  i : integer;
begin
   redDisplay.clear;
   redDisplay.Paragraph.TabCount := 1;
   redDisplay.Paragraph.Tab[0] := 120;
   redDisplay.Lines.Add('NAME' + #9 + 'SCORE');
   for i := 1 to iCount do
    begin
      redDisplay.Lines.Add(arrNames[i] + #9 + IntToStr(arrScores[i]));
    end;
end;

end.
